searchNodes=[{"ref":"StrawHat.html","title":"StrawHat","type":"module","doc":"Utility package used on Straw Hat Ecosystem."},{"ref":"StrawHat.html#identity/1","title":"StrawHat.identity/1","type":"function","doc":"A returns the parameter back. Examples iex&gt; StrawHat.identity(1) 1"},{"ref":"StrawHat.html#pipe/2","title":"StrawHat.pipe/2","type":"function","doc":"Pipes the subject through the given anonymous function and returns function&#39;s result. This function is useful to pipe the subject through an anonymous function, without having to do 1 |&gt; (&amp;to_string/1).(), which is a little bit to much parens. Examples iex&gt; 1 |&gt; StrawHat.pipe(&amp;to_string/1) &quot;1&quot;"},{"ref":"StrawHat.html#tap/2","title":"StrawHat.tap/2","type":"function","doc":"Pipes the subject through the given anonymous function but always returns subject. This function might be useful in situations you want to transform the subject in something else and print it, or to save it to a file. Basically anything which may generate some side effects but you don&#39;t care about the results. Examples iex&gt; 1 |&gt; StrawHat.tap(&amp;to_string/1) |&gt; Kernel.+(1) 2"},{"ref":"StrawHat.Configurable.html","title":"StrawHat.Configurable","type":"module","doc":"It defines a configurable module. A configurable module expose config function that returns the configuration of the module based a merge strategy. The configuration will use three configurations: Using the macro parameters, most likely used for static values. Using Config module, most likely used for environment-based values. Runtime based on the parameters, most likely used when you want to control the values at runtime. Static Configuration When you need to define default values that do not require runtime execution nor they are based on the environment. They are most likely static values. defmodule MyConfigurableModule do use StrawHat.Configurable, config: [ site: &quot;https://myproductionsite.com&quot; ] end Environment Configuration When you pass the otp_app, we will lookup based on the OTP app name and the module name. defmodule MyConfigurableModule do use StrawHat.Configurable, otp_app: :my_app end Then you can configure the values in your config files. config :my_app, MyConfigurableModule, some_value_here: &quot;&quot; This will allow you to swap values based on the environment. Runtime Configuration Since your module will contain the config function, you can always call it with extra configs. MyConfigurableModule.config([ another_value: &quot;&quot; ])"},{"ref":"StrawHat.Ecto.Changeset.html","title":"StrawHat.Ecto.Changeset","type":"module","doc":"Some utils functions around Ecto.Changeset"},{"ref":"StrawHat.Ecto.Changeset.html#transform_to_map/1","title":"StrawHat.Ecto.Changeset.transform_to_map/1","type":"function","doc":"A helper that transform changeset errors to a map of messages."},{"ref":"StrawHat.Error.html","title":"StrawHat.Error","type":"module","doc":"Used for Error handling. The StrawHat&#39;s philosophy is to have data structure as much as we can. Usage One example of the struct could be with Ecto. When you want to find some record but it does not exists on the database. Examples case Repo.get(UserSchema, id) do nil -&gt; {:error, StrawHat.Error.new(&quot;user.not_found&quot;, metadata: [user_id: id])} user -&gt; {:ok, user} end"},{"ref":"StrawHat.Error.html#new/1","title":"StrawHat.Error.new/1","type":"function","doc":"Converts an Ecto.Changeset.t/0 to StrawHat.Error.ErrorList.t/0 error."},{"ref":"StrawHat.Error.html#new/2","title":"StrawHat.Error.new/2","type":"function","doc":"Returns a StrawHat.Error.t/0."},{"ref":"StrawHat.Error.html#t:opts/0","title":"StrawHat.Error.opts/0","type":"type","doc":""},{"ref":"StrawHat.Error.html#t:t/0","title":"StrawHat.Error.t/0","type":"type","doc":"id: Unique identifier setup by the System. Used for tracking, it&#39;s unique per instance of the Error. Default: UUID.uuid1(). code: Represent the ID defined by your system designed. Example: &quot;straw_hat.validation.required&quot; type: Categorize/Group your errors. Default &quot;generic&quot;. metadata: A set of key value with useful information about the error."},{"ref":"StrawHat.Error.ChangesetParser.html","title":"StrawHat.Error.ChangesetParser","type":"module","doc":"Ecto.Changeset parser that transforms the Ecto.Changeset errors into list of %StrawHat.Error{}."},{"ref":"StrawHat.Error.ChangesetParser.html#parse/1","title":"StrawHat.Error.ChangesetParser.parse/1","type":"function","doc":"Parse an %Ecto.Changeset{} errors into a list of %StrawHat.Error{}."},{"ref":"StrawHat.Error.ErrorList.html","title":"StrawHat.Error.ErrorList","type":"module","doc":"Data structure that represents a list of StrawHat.Error.t/0."},{"ref":"StrawHat.Error.ErrorList.html#new/1","title":"StrawHat.Error.ErrorList.new/1","type":"function","doc":"Creates an StrawHat.Error.ErrorList.t/0"},{"ref":"StrawHat.Error.ErrorList.html#t:t/0","title":"StrawHat.Error.ErrorList.t/0","type":"type","doc":"List of Errors. errors: List of StrawHat.Error.t/0."},{"ref":"StrawHat.Error.ErrorMetadata.html","title":"StrawHat.Error.ErrorMetadata","type":"module","doc":"Metadata used on StrawHat.Error.t/0. It is a representation of key value pair into StrawHat.Error.ErrorMetadata.t/0. Most likely used through StrawHat.Error."},{"ref":"StrawHat.Error.ErrorMetadata.html#new/1","title":"StrawHat.Error.ErrorMetadata.new/1","type":"function","doc":"Creates a StrawHat.Error.ErrorMetadata.t/0 from a tuple."},{"ref":"StrawHat.Error.ErrorMetadata.html#new/2","title":"StrawHat.Error.ErrorMetadata.new/2","type":"function","doc":"Creates a StrawHat.Error.ErrorMetadata.t/0."},{"ref":"StrawHat.Error.ErrorMetadata.html#serialize/1","title":"StrawHat.Error.ErrorMetadata.serialize/1","type":"function","doc":"Serializes a Keyword list into a list of StrawHat.Error.ErrorMetadata.t/0."},{"ref":"StrawHat.Error.ErrorMetadata.html#t:t/0","title":"StrawHat.Error.ErrorMetadata.t/0","type":"type","doc":"key: Key of the metadata. value: Value of the metadata."},{"ref":"StrawHat.Response.html","title":"StrawHat.Response","type":"module","doc":"Utilities for working with &quot;result tuples&quot;. {:ok, value} {:error, reason}"},{"ref":"StrawHat.Response.html#and_then/2","title":"StrawHat.Response.and_then/2","type":"function","doc":"Calls the next function only if it receives an ok tuple. Otherwise it skips the call and returns the error tuple. Examples iex&gt; business_logic = fn x -&gt; StrawHat.Response.ok(x * 2) end ...&gt; 21 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.and_then(business_logic) {:ok, 42} iex&gt; business_logic = fn x -&gt; StrawHat.Response.ok(x * 2) end ...&gt; &quot;oops&quot; |&gt; StrawHat.Response.error() |&gt; StrawHat.Response.and_then(business_logic) {:error, &quot;oops&quot;}"},{"ref":"StrawHat.Response.html#either/3","title":"StrawHat.Response.either/3","type":"function","doc":"Calls the first function if it receives an error tuple, and the second one if it receives an ok tuple. Examples iex&gt; on_ok = fn x -&gt; &quot;X is \#{x}&quot; end ...&gt; on_error = fn e -&gt; &quot;Error: \#{e}&quot; end ...&gt; 42 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.either(on_error, on_ok) &quot;X is 42&quot; iex&gt; on_ok = fn x -&gt; &quot;X is \#{x}&quot; end ...&gt; on_error = fn e -&gt; &quot;Error: \#{e}&quot; end ...&gt; &quot;oops&quot; |&gt; StrawHat.Response.error() |&gt; StrawHat.Response.either(on_error, on_ok) &quot;Error: oops&quot;"},{"ref":"StrawHat.Response.html#error/1","title":"StrawHat.Response.error/1","type":"function","doc":"Creates a new error result tuple. Examples iex&gt; StrawHat.Response.error(&quot;oops&quot;) {:error, &quot;oops&quot;}"},{"ref":"StrawHat.Response.html#error?/1","title":"StrawHat.Response.error?/1","type":"function","doc":"Checks if a result_tuple is an error. Examples iex&gt; 1 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.error?() false iex&gt; 2 |&gt;StrawHat.Response.error() |&gt; StrawHat.Response.error?() true"},{"ref":"StrawHat.Response.html#from_value/2","title":"StrawHat.Response.from_value/2","type":"function","doc":"Promotes any value to a result tuple. It excludes nil for the ok tuples. Examples iex&gt; StrawHat.Response.from_value(nil) {:error, :no_value} iex&gt; StrawHat.Response.from_value(nil, &quot;Missing&quot;) {:error, &quot;Missing&quot;} iex&gt; StrawHat.Response.from_value(42) {:ok, 42} iex&gt; StrawHat.Response.from_value({:ok, 123}) {:ok, 123} iex&gt; StrawHat.Response.from_value({:error, &quot;my error&quot;}) {:error, &quot;my error&quot;}"},{"ref":"StrawHat.Response.html#keep_if/3","title":"StrawHat.Response.keep_if/3","type":"function","doc":"Converts an Ok value to an Error value if the predicate is not valid. Examples iex&gt; res = StrawHat.Response.ok(10) ...&gt; StrawHat.Response.keep_if(res, &amp;(&amp;1 &gt; 5)) {:ok, 10} iex&gt; res = StrawHat.Response.ok(10) ...&gt; StrawHat.Response.keep_if(res, &amp;(&amp;1 &gt; 10), &quot;must be &gt; of 10&quot;) {:error, &quot;must be &gt; of 10&quot;} iex&gt; res = StrawHat.Response.error(:no_value) ...&gt; StrawHat.Response.keep_if(res, &amp;(&amp;1 &gt; 10), &quot;must be &gt; of 10&quot;) {:error, :no_value}"},{"ref":"StrawHat.Response.html#map/2","title":"StrawHat.Response.map/2","type":"function","doc":"Calls the next function only if it receives an ok tuple. The function unwraps the value from the tuple, calls the next function and wraps it back into an ok tuple. Examples iex&gt; business_logic = fn x -&gt; x * 2 end ...&gt; 21 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.map(business_logic) {:ok, 42} iex&gt; business_logic = fn x -&gt; x * 2 end ...&gt; &quot;oops&quot; |&gt; StrawHat.Response.error() |&gt; StrawHat.Response.map(business_logic) {:error, &quot;oops&quot;}"},{"ref":"StrawHat.Response.html#map_error/2","title":"StrawHat.Response.map_error/2","type":"function","doc":"Calls the next function only if it receives an error tuple. The function unwraps the value from the tuple, calls the next function and wraps it back into an error tuple. Examples iex&gt; better_error = fn _ -&gt; &quot;A better error message&quot; end ...&gt; 42 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.map_error(better_error) {:ok, 42} iex&gt; better_error = fn _ -&gt; &quot;A better error message&quot; end ...&gt; &quot;oops&quot; |&gt; StrawHat.Response.error() |&gt; StrawHat.Response.map_error(better_error) {:error, &quot;A better error message&quot;}"},{"ref":"StrawHat.Response.html#ok/1","title":"StrawHat.Response.ok/1","type":"function","doc":"Creates a new ok result tuple. Examples iex&gt; StrawHat.Response.ok(42) {:ok, 42}"},{"ref":"StrawHat.Response.html#ok?/1","title":"StrawHat.Response.ok?/1","type":"function","doc":"Checks if a result_tuple is ok. Examples iex&gt; 1 |&gt; StrawHat.Response.ok() |&gt; StrawHat.Response.ok?() true iex&gt; 2 |&gt; StrawHat.Response.error() |&gt;StrawHat.Response.ok?() false"},{"ref":"StrawHat.Response.html#or_else/2","title":"StrawHat.Response.or_else/2","type":"function","doc":"Calls the next function only if it receives an error tuple. Otherwise it skips the call and returns the ok tuple. It expects the function to return a new result tuple. Examples iex&gt; business_logic = fn _ -&gt; {:error, &quot;a better error message&quot;} end ...&gt; {:ok, 42} |&gt; StrawHat.Response.or_else(business_logic) {:ok, 42} iex&gt; business_logic = fn _ -&gt; {:error, &quot;a better error message&quot;} end ...&gt; {:error, &quot;oops&quot;} |&gt; StrawHat.Response.or_else(business_logic) {:error, &quot;a better error message&quot;} iex&gt; default_value = fn _ -&gt; {:ok, []} end ...&gt; {:error, &quot;oops&quot;} |&gt; StrawHat.Response.or_else(default_value) {:ok, []}"},{"ref":"StrawHat.Response.html#reject_if/3","title":"StrawHat.Response.reject_if/3","type":"function","doc":"Converts an Ok value to an Error value if the predicate is valid. Examples iex&gt; res = StrawHat.Response.ok([]) ...&gt; StrawHat.Response.reject_if(res, &amp;Enum.empty?/1) {:error, :invalid} iex&gt; res = StrawHat.Response.ok([1]) ...&gt; StrawHat.Response.reject_if(res, &amp;Enum.empty?/1) {:ok, [1]} iex&gt; res = StrawHat.Response.ok([]) ...&gt; StrawHat.Response.reject_if(res, &amp;Enum.empty?/1, &quot;list cannot be empty&quot;) {:error, &quot;list cannot be empty&quot;}"},{"ref":"StrawHat.Response.html#sequence/1","title":"StrawHat.Response.sequence/1","type":"function","doc":"Transforms a list of result tuple to a result tuple containing either the first error tuple or an ok tuple containing the list of values. Examples iex&gt; StrawHat.Response.sequence([StrawHat.Response.ok(42), StrawHat.Response.ok(1337)]) {:ok, [42, 1337]} iex&gt; StrawHat.Response.sequence([StrawHat.Response.ok(42), StrawHat.Response.error(&quot;oops&quot;), StrawHat.Response.ok(1337)]) {:error, &quot;oops&quot;}"},{"ref":"StrawHat.Response.html#tap/2","title":"StrawHat.Response.tap/2","type":"function","doc":"Calls the next function only if it receives an ok tuple but discards the result. It always returns the original tuple. Examples iex&gt; some_logging = fn x -&gt; &quot;Success \#{x}&quot; end ...&gt; {:ok, 42} |&gt; StrawHat.Response.tap(some_logging) {:ok, 42} iex&gt; some_logging = fn _ -&gt; &quot;Not called logging&quot; end ...&gt; {:error, &quot;oops&quot;} |&gt; StrawHat.Response.tap(some_logging) {:error, &quot;oops&quot;}"},{"ref":"StrawHat.Response.html#tap_error/2","title":"StrawHat.Response.tap_error/2","type":"function","doc":"Calls the next function only if it receives an error tuple but discards the result. It always returns the original tuple. Examples iex&gt; some_logging = fn x -&gt; &quot;Failed \#{x}&quot; end ...&gt; {:error, &quot;oops&quot;} |&gt; StrawHat.Response.tap_error(some_logging) iex&gt; somelogging = fn -&gt; &quot;Not called logging&quot; end ...&gt; {:ok, 42} |&gt; StrawHat.Response.tap_error(some_logging)"},{"ref":"StrawHat.Response.html#with_default/2","title":"StrawHat.Response.with_default/2","type":"function","doc":"Returns the content of an ok tuple if the value is correct. Otherwise it returns the default value. Examples iex&gt; 42 |&gt; StrawHat.Response.ok |&gt; StrawHat.Response.with_default(1337) 42 iex&gt; &quot;oops&quot; |&gt; StrawHat.Response.error |&gt; StrawHat.Response.with_default(1337) 1337"},{"ref":"StrawHat.Response.html#t:error_tuple/0","title":"StrawHat.Response.error_tuple/0","type":"type","doc":""},{"ref":"StrawHat.Response.html#t:ok_tuple/0","title":"StrawHat.Response.ok_tuple/0","type":"type","doc":""},{"ref":"StrawHat.Response.html#t:result_tuple/0","title":"StrawHat.Response.result_tuple/0","type":"type","doc":""},{"ref":"StrawHat.Response.html#t:t/2","title":"StrawHat.Response.t/2","type":"type","doc":""},{"ref":"StrawHat.Utils.Map.html","title":"StrawHat.Utils.Map","type":"module","doc":"Functions for transforming maps, keys and values."},{"ref":"StrawHat.Utils.Map.html#atomize_keys/2","title":"StrawHat.Utils.Map.atomize_keys/2","type":"function","doc":"Transforms a map&#39;s String.t keys to atom() keys. options is a keyword list of options. The available option is: :only_existing which is set to true will only convert the binary key to an atom if the atom already exists. The default is false."},{"ref":"StrawHat.Utils.Map.html#atomize_values/2","title":"StrawHat.Utils.Map.atomize_values/2","type":"function","doc":"Transforms a map&#39;s String.t values to atom() values. options is a keyword list of options. The available option is: :only_existing which is set to true will only convert the binary value to an atom if the atom already exists. The default is false."},{"ref":"StrawHat.Utils.Map.html#deep_map/2","title":"StrawHat.Utils.Map.deep_map/2","type":"function","doc":"Recursively traverse a map and invoke a function for each key/ value pair that transforms the map. Examples iex&gt; map = %{a: &quot;a&quot;, b: %{c: &quot;c&quot;}} iex&gt; StrawHat.Utils.Map.deep_map map, fn {k, v} -&gt; ...&gt; {k, String.upcase(v)} ...&gt; end %{a: &quot;A&quot;, b: %{c: &quot;C&quot;}}"},{"ref":"StrawHat.Utils.Map.html#deep_map/3","title":"StrawHat.Utils.Map.deep_map/3","type":"function","doc":"Recursively traverse a map and invoke a function for each key and a function for each value that transform the map. key_function is a function or function reference that is called for each key of the provided map and any keys of any submaps value_function is a function or function reference that is called for each value of the provided map and any values of any submaps"},{"ref":"StrawHat.Utils.Map.html#stringify_keys/1","title":"StrawHat.Utils.Map.stringify_keys/1","type":"function","doc":"Transforms a map&#39;s atom() keys to String.t keys."},{"ref":"StrawHat.Utils.Map.AtomizeKeyError.html","title":"StrawHat.Utils.Map.AtomizeKeyError","type":"exception","doc":""},{"ref":"StrawHat.Utils.Map.AtomizeKeyError.html#message/1","title":"StrawHat.Utils.Map.AtomizeKeyError.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"StrawHat.Utils.Map.AtomizeKeyError.html#t:t/0","title":"StrawHat.Utils.Map.AtomizeKeyError.t/0","type":"type","doc":""},{"ref":"readme.html","title":"StrawHat","type":"extras","doc":"StrawHat Utility package, includes some data structures around errors and tuple responses."}]